//视图对象
var _view;
//当前激活的时移页头dom
var  _lastTSHeader;
//当前状态 1/2/3  1:预告   2:本周回看   3:上周回看
var _page=2;

//视图加载
exports.onLoad = function(view, params)
{
	_view = view;
	//初始化tab页
	fillTSPage({});
    _page =2;
	//给tab安装事件处理
	var dayTabs = $(".tv_new_epg .header_day", _view);
	for(var i=0; i<dayTabs.length; ++i) {
		$(dayTabs[i]).click(function(index) {			
			setTSPage('.tv_new_epg', this, index);
		}.bind(dayTabs[i], i));
	}

	dayTabs = $(".tv_old_epg .header_day", _view);
	for(var i=0; i<dayTabs.length; ++i) {
		$(dayTabs[i]).click(function(index) {			
			setTSPage('.tv_old_epg', this, index);
		}.bind(dayTabs[i], i));		
	}

    dayTabs = $(".tv_sec_epg .header_day", _view);
    for(var i=0; i<dayTabs.length; ++i) {
        $(dayTabs[i]).click(function(index) {
            setTSPage('.tv_sec_epg', this, index);
        }.bind(dayTabs[i], i));
    }
    //回看按钮，切换向前一周
    $(".tv_ts_info_forward_panel .header_text", _view).click(function() {
        if(_page == 2){
            setTSPage('.tv_new_epg', $('.tv_new_epg .header_last', _view)[0], 6, true);
            _page=1;
        }else if(_page == 3){
            setTSPage('.tv_old_epg', $('.tv_old_epg .header_first', _view)[0], 0, true);
            _page=2;
        }else {
            //FIX ME  disable left button
        }
        //setTSPage('.tv_old_epg', $('.tv_old_epg .header_first', _view)[0], 0, true);
    });

    //回看按钮，切换回退向后一周
    $(".tv_ts_info_bacdward_panel .header_text", _view).click(function() {
        if(_page == 2){
            setTSPage('.tv_sec_epg', $('.tv_sec_epg .header_first', _view)[0], 0, true);
            _page=3;
        }else if(_page == 1){
            setTSPage('.tv_old_epg', $('.tv_old_epg .header_first', _view)[0], 0, true);
            _page=2;
        }else {
            //FIX ME  disable right button
        }
        //setTSPage('.tv_old_epg', $('.tv_old_epg .header_first', _view)[0], 0, true);
    });

}

//激活时移页, header 为新的时移页头dom, index 为时移页索引
function setTSPage(parentClass, header, index, changeFocus)
{
	if (parentClass == '.tv_new_epg') { //新旧EPG切换
		$(parentClass).css('display', 'block');
		$('.tv_old_epg', _view).css('display', 'none');
        $('.tv_sec_epg', _view).css('display', 'none');
    }else if (parentClass == '.tv_sec_epg') { //新旧EPG切换
        $(parentClass).css('display', 'block');
        $('.tv_new_epg', _view).css('display', 'none');
        $('.tv_old_epg', _view).css('display', 'none');
    }else {
		$(parentClass).css('display', 'block');
        $('.tv_sec_epg', _view).css('display', 'none');
        $('.tv_new_epg', _view).css('display', 'none');
	}
	if (_lastTSHeader) $(_lastTSHeader).removeClass("kn_current");
	_lastTSHeader = header;
	$(header).addClass("kn_current");
	var pannels = $(parentClass + ' .tv_ts_info_panel', _view);
	pannels.css('display', 'none');			
	$(pannels[index]).css('display', 'block');			
	var e = pannels[index];			
	//e.scroller = new IScroll(e, {bounce: false, useTransition: false});
	pannels[index].scrollTop = 0;
	if (changeFocus) {		
		VMSUI.KN.setFocus(header);
	}
}
		
function toTextN(v, n)
{
	v = v + "";
	while(v.length < n) {
			v = '0' + v;
	}
	return v;
}
		
//星期的文字
var gDayText = ["日",  "月", "火",  "水",  "木", "金", "土"];
//当前播放节目名
var gCurTitleName='N/A';
var gCurTitleDate='N/A';

function getCurrentDate(t)
{
	var r;
	if (window.getCurrentTime) {
		r = window.getCurrentTime(true);
	} else {
		r = new Date();
	}
	if (t === undefined) return r;
	else r.setTime(t);
	return r;
}

function getDayText(day)
{
	if (PlayerCtx.translation) {
		var dtxt = PlayerCtx.translation.day_names;
	} else {
		var dtxt = gDayText;
	}
	return dtxt[day];
}
/*!
@brief 填充EPG录制页
@param chn 频道对象
*/
function fillTSPage(chn) 
{
	if (!chn) return;
	var emptyDIV = document.createElement('div');
	var epg = chn.record_epg;
	if (!epg) epg=[];
	else {
		try {
			epg = p2psr.parseJSON(epg);				
		} catch(e) {
			console.log("Exception: " + e);
		}
	}
	var defaultMovieLevel  = chn.movie_level;	
	var ostate = VMSUI.KN.saveState(_view);	
	ostate.custom={last: lastSelectedTS};
	//tab头，按日期新旧倒序排列
	var dayHeader = $(".header_day .header_text", _view);			
	//每天的开始时间ms, 按日期新旧倒序排列
	var dayTimes=[];			
	//构建日期头
	var  tody = getCurrentDate();	
	tody.setHours(0);
	tody.setMinutes(0);
	tody.setSeconds(0);
	tody.setMilliseconds(0);	
	gCurTitleDate = getDayText(tody.getDay())+ "　" + toTextN(tody.getMonth()+1, 2) + "/" + toTextN(tody.getDate(), 2);
	tody.setTime(tody.getTime()+7*24*3600*1000);				
	for(var i=0; i<21; ++i) {
		dayTimes.push({start: tody.getTime(), end: tody.getTime() + 24*3600*1000});
		$(dayHeader[i]).html(getDayText(tody.getDay()) + " <span class=\"day\">"+ toTextN(tody.getMonth()+1, 2) + "/"+ toTextN(tody.getDate(), 2) + "</span>");
		tody.setTime(tody.getTime()-24*3600*1000);				
	}
 //tab 页面，按日期从新到旧排列
 var pannels = $(".kn_ts_info_panel", _view);
 //pannels.empty();
 for(var i=0; i<pannels.length; ++i) {
	$(pannels[i]).empty();
	pannels[i].__model = null;
 }
 var index=0;
 var now = getCurrentDate().getTime();
 var currentSet = false;
 gCurTitleName = 'N/A';
 var tabIndex = 30000;
 var pageModel;
 
 var quit = false;
 //扫描EPG， 从新往旧
 for(var i=epg.length-1; i>=0 && !quit; --i) {	
	var e = epg[i];
	 var t = e.time*1000;
	 while(t < dayTimes[index].start) {
			index++;
			if (index > 20) {
				quit = true;
				break;
			}
		}			   
		if (quit) break;
		
		if (t < dayTimes[index].end) {
			var timeStr = getCurrentDate(t);			
			timeStr = toTextN(timeStr.getHours(), 2) + ":" + toTextN(timeStr.getMinutes(), 2);					
			if (e.path && e.path != "") { //已经录制						
				if (index == 7 && !currentSet && t < now) {
					currentSet = true;
					gCurTitleName = e.title;
					emptyDIV.innerHTML = "<div  tabindex=\"" + tabIndex + "\" class=\"tv_epg_item tv_epg_current\"><div class=\"epg_time\">" + timeStr  + "</div><div class=\"epg_title\">" +  VMSUI.encodeHTML(e.title) + 
					"</div><div class=\"epg_type\">"  + PlayerCtx.translation.live_program +
					"</div><div class=\"clear\"></div></div>";
				} else {
					emptyDIV.innerHTML = "<div  tabindex=\"" + tabIndex + "\" class=\"tv_epg_item\"><div class=\"epg_time\">" + timeStr  + "</div><div class=\"epg_title\">" +  VMSUI.encodeHTML(e.title) + "</div><div class=\"epg_type\">" 
					+ PlayerCtx.translation.record_program + "</div><div class=\"clear\"></div></div>";
				}
			} else  { //未录制
				if  (t > now) { //这是节目预告						
						emptyDIV.innerHTML = "<div  tabindex=\"" + tabIndex + "\" class=\"tv_epg_item\"><div class=\"epg_time\">" + timeStr  + "</div><div class=\"epg_title\">" +  VMSUI.encodeHTML(e.title) + "</div><div class=\"epg_type\">"
						+ PlayerCtx.translation.guide_program + "</div><div class=\"clear\"></div></div>";
				} else if (index == 7 && !currentSet) {
					currentSet = true;
					gCurTitleName = e.title;
					emptyDIV.innerHTML = "<div tabindex=\"" + tabIndex + "\" class=\"tv_epg_item tv_epg_current\"><div class=\"epg_time\">" + timeStr  + "</div><div class=\"epg_title\">" +  VMSUI.encodeHTML(e.title) + "</div><div class=\"epg_type\">" 
					+ PlayerCtx.translation.live_program + "</div><div class=\"clear\"></div></div>";
				}
			}					
			var ch = emptyDIV.firstChild;
			if (!ch) {
				//console.log((getCurrentTime(t)) + ":" + e.title);
				continue;
			}
			tabIndex--;
			e.timeText = timeStr;
			ch.__model = e;			
			if (e.movie_level == 0 || e.movie_level == null) {
				e.movie_level = defaultMovieLevel;
			}
			if (pannels[index].firstChild) {
				e.pageIndex = index;
				pageModel.unshift(e);
				pannels[index].__model = pageModel;
				pannels[index].insertBefore(ch, pannels[index].firstChild);
			} else {
				e.pageIndex = index;
				if (pageModel) {
					for(var j=0; j<pageModel.length; ++j) {
						pageModel[j].index = j;
					}
				}
				pageModel=[e];				
				pannels[index].__model = pageModel;
				pannels[index].appendChild(ch);
			}
			$(ch).click(function() {
				playTS(this);
			});
		}
	}		
	if (pageModel) {
		for(var j=0; j<pageModel.length; ++j) {
				pageModel[j].index = j;
			}
	}	
	 VMSUI.KN.restoreState(ostate, _view, function(odom, ndom) {
		if (odom.__model == null) return false;
		if (ndom.__model == null) return false;		
		return odom.__model.time == ndom.__model.time;
	 });
	 lastSelectedTS = ostate.custom.last;
	 if (lastSelectedTS) {
		 if (lastPlayTS) lastPlayTS = lastSelectedTS;
	 } else {
		lastPlayTS = null;
	 }
	 var cur = $('.tv_epg_current', _view)[0];
	 if (cur) {
		$(cur).addClass('kn_old_focus');
		setTimeout(function() {
			VMSUI.makeVisible(cur);
		}, 0);
	 }
	$(_view).trigger('data_updated');
}
 
//当前播放时移条目dom
var lastPlayTS;
var lastSelectedTS;

//播放时移条目
function playTS(it)
{
	if (lastPlayTS == it)  {
		$(_view).trigger('playsame', it.__model);
		return;
	}
	if (it.__model.path == null || it.__model.path == '') return;
	if (lastSelectedTS) $(lastSelectedTS).removeClass("kn_current");
	$(it).addClass("kn_current");
	var oit = lastSelectedTS;	
	lastPlayTS = lastSelectedTS = it;	
	var m = it.__model;
	var d = getCurrentDate(m.time * 1000);
	var dateText = getDayText(d.getDay()) + "　" +  toTextN(d.getMonth()+1, 2) + "/" + toTextN(d.getDate(), 2);		
	VMSUI.KN.setFocus(it);
	setTimeout(function() {
			VMSUI.makeVisible(it);
	}, 0);
	$(_view).trigger('playnew', {path: m.path, live: false, dateText: dateText, title: m.title, m: it.__model, index: it.__model.index});	
	if (!oit || oit.__model.pageIndex != it.__model.pageIndex) {
		$(_view).trigger('play_page_changed');
	}
}		

/*!
事件列表

- playsame 重复点击播放之前的条目 p1=时移信息对象{title: 标题, time: 时间（秒）, path: 路径}
- playnew 新点击播放条目 p1=时移信息对象 p2=播放条目信息 {title: 标题, dateText: 日期标题, live: 是否是直播, path: 路径}
*/

//导出fillTSPage函数
exports.fillTSPage = fillTSPage;

exports.resetPageStatus=function(){
    _page = 2;
}

//设置激活页函数
exports.setActivePage = function(old, index)
{
	if (index > 6) return false;
	if (old) {
		setTSPage('.tv_old_epg', $('.tv_old_epg .header_day', _view)[index], index);
	} else {
		setTSPage('.tv_new_epg', $('.tv_new_epg .header_day', _view)[index], index);
	}
	return true;
}

//重置上次播放条目
exports.resetLastPlay = function()
{
	if (lastPlayTS) {
		$(lastPlayTS).removeClass('kn_current');
	}
	lastPlayTS = null;	
}

//获取当前日期名
exports.getCurrentDateText = function()
{
	return gCurTitleDate;
}
//获取频道正在播放的节目的标题
exports.getCurrentProgramName = function()
{
	return  gCurTitleName;
}

//播放下一个时移节目
exports.nextTS = function()
{
	if (lastSelectedTS == null) return false;
	var next = lastSelectedTS.nextSibling;
	if (!next) return false;
	if (next.__model.path == null || next.__model.path == '') return false;
	playTS(next);
	return true;
}

//获取当前页的时移列表数据
exports.getCurrentTSS = function()
{
	if (lastSelectedTS == null) return null;
	var pannels = $(".kn_ts_info_panel", _view);
	var idx = lastSelectedTS.__model.pageIndex;
	var m = pannels[idx].__model;
	return m;	
}

//获取当前播放条目的索引
exports.getCurrentPlayIndex = function()
{
	if (lastSelectedTS == null) return -1;
	return lastSelectedTS.__model.index;
}

//按当前页内索引播放
exports.playByIndex = function(index)
{
	if (lastSelectedTS == null)  {
		return null;
	}
	var pannels = $(".kn_ts_info_panel", _view);
	var idx = lastSelectedTS.__model.pageIndex;
	var its = $('.tv_epg_item', pannels[idx]);	
	for(var i=0; i<its.length; ++i) {
		if (its[i].__model.index == index) {
			playTS(its[i]);
			return true;
		}
	}	
	return false;
}